<?php
class PostsController extends AppController {
	var $name = 'Posts';
	var $components = array('Auth', 'Acl', 'Access');
	var $helpers = array('Access');
	
	function beforeFilter(){
		$this->Auth->userModel = 'User';
		$this->Auth->allow(array('index', 'view'));
	}
	
	function index(){
		$posts = $this->Post->find('all');
		$this->set('posts', $posts);
	}
	
	function create(){
		if(!empty($this->data)){
			$this->Post->save($this->data);
			$this->Session->setFlash('Post created successfully.');
			$this->redirect($this->here);
		}
	}
	
	function edit($id){
		if(!$this->Access->check('Post', 'update')) $this->cakeError('error404');
		$post = $this->Post->find('first', array(
			'conditions' => array(
				'Post.id' => $id
			)
		));
		
		if(!empty($this->data)){
			$this->Post->save($this->data);
			$this->Session->setFlash('Post modified successfully.');
			$this->redirect($this->here);
		} else {
			$this->data = $post;
		}
	}
	
	function view($id){
		$post = $this->Post->find('first', array(
			'conditions' => array(
				'Post.id' => $id
			)
		));
		$this->set('post', $post);
	}
	
	function delete($id){
		$this->Post->del($id);
		$this->Session->setFlash('Post deleted successfully.');
		$this->redirect($this->referer());
	}
}
?>